SystemOrganization addCategory: #Pharobot!

TransformationMorph subclass: #Robot
	instanceVariableNames: 'mundo direccion estado_pincelArriba estado_pincelAbajo estado_pincelActual ultimaPosicion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pharobot'!

!Robot class methodsFor: 'crear instancia' stamp: 'MorellatoAriel 3/1/2012 00:40'!
"Luego de crear un robot hay que mandarle el mensaje 'inicializarRobot' "

crearRobot: unMundo

|nuevoRobot|

nuevoRobot:= self new.
nuevoRobot mundo: unMundo.
unMundo robot: nuevoRobot.
nuevoRobot position: (nuevoRobot mundo position x + (nuevoRobot mundo extent x / 2) ) @ (nuevoRobot mundo position y + (nuevoRobot mundo extent y / 2)).
^ nuevoRobot openInWorld .
! !

!Robot methodsFor: 'pincel' stamp: 'MorellatoAriel 2/28/2012 17:39'!
bajarPincel

self estado_pincelActual: self estado_pincelAbajo.! !

!Robot methodsFor: 'caminos' stamp: 'MorellatoAriel 2/28/2012 21:06'!
borrarCaminos

self mundo caminos do:  [:elem | elem delete.].
self mundo caminos: Set new.! !

!Robot methodsFor: 'accessing' stamp: 'MorellatoAriel 2/28/2012 00:40'!
direccion
	^ self angle radiansToDegrees .! !

!Robot methodsFor: 'accessing' stamp: 'MorellatoAriel 3/1/2012 11:34'!
direccion: unAngulo
	self angle: unAngulo degreesToRadians.
	self position: self ultimaPosicion .
! !

!Robot methodsFor: 'accessing' stamp: 'MorellatoAriel 2/27/2012 23:59'!
estado_pincelAbajo
	^ estado_pincelAbajo! !

!Robot methodsFor: 'accessing' stamp: 'MorellatoAriel 2/27/2012 23:59'!
estado_pincelAbajo: anObject
	estado_pincelAbajo := anObject! !

!Robot methodsFor: 'accessing' stamp: 'MorellatoAriel 2/27/2012 23:59'!
estado_pincelActual
	^ estado_pincelActual! !

!Robot methodsFor: 'accessing' stamp: 'MorellatoAriel 2/27/2012 23:59'!
estado_pincelActual: anObject
	estado_pincelActual := anObject! !

!Robot methodsFor: 'accessing' stamp: 'MorellatoAriel 2/27/2012 23:59'!
estado_pincelArriba
	^ estado_pincelArriba! !

!Robot methodsFor: 'accessing' stamp: 'MorellatoAriel 2/27/2012 23:59'!
estado_pincelArriba: anObject
	estado_pincelArriba := anObject! !

!Robot methodsFor: 'inicializar' stamp: 'MorellatoAriel 3/1/2012 00:58'!
inicializarRobot

|piezaUno piezaDos piezaTres piezaCuatro piezaCinco pixel posInicial|
"Cuerpo"
piezaUno:= BorderedMorph new.
piezaUno extent: 20@40.
piezaUno color: (Color lightGreen  ).
piezaUno borderColor: Color green.
piezaUno openInWorld .
piezaUno position: self position. 
self asFlexOf: piezaUno.

"Ojo izquierdo"
piezaDos:= CircleMorph new.
piezaDos extent: 10@10.
piezaDos color: (Color blue alpha: 0.5).
piezaDos position: (piezaUno position x + 7) @ (piezaUno position y + 5).
piezaDos openInWorld .
piezaUno addMorph: piezaDos.

"Ojo derecho"
piezaTres:= CircleMorph new.
piezaTres extent: 10@10.
piezaTres color: (Color blue alpha: 0.5).
piezaTres position: (piezaUno position x + 7) @ (piezaUno position y + 23).
piezaTres openInWorld .
piezaUno addMorph: piezaTres.

"Bolita del ojo 1"
piezaCuatro:= CircleMorph new.
piezaCuatro extent: 5@5.
piezaCuatro color: Color black .
piezaCuatro position: (piezaDos position x + 5) @ (piezaDos position y + 3) .
piezaCuatro openInWorld .
piezaDos addMorph: piezaCuatro.

"Bolita del ojo 2"
piezaCinco:= CircleMorph new.
piezaCinco extent: 5@5.
piezaCinco color: Color black .
piezaCinco position: (piezaTres position x + 5) @ (piezaTres position y + 3) .
piezaCinco openInWorld .
piezaTres addMorph: piezaCinco.

"Cuerpo del robot "

posInicial:= (piezaUno position x + 20) @ (piezaUno position y).

(8)timesRepeat: 
[pixel:= Morph new.
pixel extent: 2@2.
pixel position: posInicial.
pixel color: Color green .
pixel openInWorld .
piezaUno addMorph: pixel.
posInicial:= (posInicial x + 2) @ (posInicial y + 2.5).].

posInicial:= (piezaUno position x + 20) @ (piezaUno position y + 37).

(8)timesRepeat: 
[pixel:= Morph new.
pixel extent: 2@2.
pixel position: posInicial.
pixel color: Color green .
pixel openInWorld .
piezaUno addMorph: pixel.
posInicial:= (posInicial x + 2) @ (posInicial y - 2.5).].

" Brazos del robot  y pincel"

posInicial:= (piezaUno position x + 26) @ (piezaUno position y + 6).

(8)timesRepeat: 
[pixel:= Morph new.
pixel extent: 2@2.
pixel position: posInicial.
pixel color: Color green .
pixel openInWorld .
piezaUno addMorph: pixel.
posInicial:= (posInicial x - 1) @ (posInicial y - 2.5).].

posInicial:= (piezaUno position x + 26) @ (piezaUno position y + 31).

(8)timesRepeat: 
[pixel:= Morph new.
pixel extent: 2@2.
pixel position: posInicial.
pixel color: Color green .
pixel openInWorld .
piezaUno addMorph: pixel.
posInicial:= (posInicial x - 1) @ (posInicial y + 2.5).].

"Pies"

posInicial:= (piezaUno position x + 37) @ (piezaUno position y + 17).
(4)timesRepeat: 
[pixel:= Morph new.
pixel extent: 2@2.
pixel position: posInicial.
pixel color: Color green .
pixel openInWorld .
piezaUno addMorph: pixel.
posInicial:= (posInicial x + 2) @ (posInicial y - 2).].

posInicial:= (piezaUno position x + 37) @ (piezaUno position y + 17).
(4)timesRepeat: 
[pixel:= Morph new.
pixel extent: 2@2.
pixel position: posInicial.
pixel color: Color green .
pixel openInWorld .
piezaUno addMorph: pixel.
posInicial:= (posInicial x + 2) @ (posInicial y + 2).].

self ultimaPosicion: self position.

"Se une el robot con su mundo"
self mundo addMorph: self.


! !

!Robot methodsFor: 'movimiento' stamp: 'MorellatoAriel 2/28/2012 17:55'!
mover: unaLongitud 

self estado_pincelActual mover: unaLongitud.! !

!Robot methodsFor: 'accessing' stamp: 'MorellatoAriel 2/27/2012 23:59'!
mundo
	^ mundo! !

!Robot methodsFor: 'accessing' stamp: 'MorellatoAriel 2/27/2012 23:59'!
mundo: anObject
	mundo := anObject! !

!Robot methodsFor: 'pincel' stamp: 'MorellatoAriel 2/28/2012 17:42'!
pincelAbajo 

^ self estado_pincelActual pincelAbajo .! !

!Robot methodsFor: 'pincel' stamp: 'MorellatoAriel 2/28/2012 17:42'!
pincelArriba  

^ self estado_pincelActual pincelArriba .! !

!Robot methodsFor: 'inicializar' stamp: 'MorellatoAriel 3/1/2012 00:21'!
reasignarRobot 

"Se une el robot con su mundo"
self mundo addMorph: self.! !

!Robot methodsFor: 'pincel' stamp: 'MorellatoAriel 2/28/2012 17:39'!
subirPincel

self estado_pincelActual: self estado_pincelArriba .! !

!Robot methodsFor: 'accessing' stamp: 'MorellatoAriel 3/1/2012 00:58'!
ultimaPosicion
	^ ultimaPosicion! !

!Robot methodsFor: 'accessing' stamp: 'MorellatoAriel 3/1/2012 00:58'!
ultimaPosicion: anObject
	ultimaPosicion := anObject! !

Morph subclass: #Mundo
	instanceVariableNames: 'robot caminos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pharobot'!

!Mundo class methodsFor: 'crear instancia' stamp: 'MorellatoAriel 2/28/2012 19:39'!
"El tamao es pasado de la siguiente manera    140 @ 140 donde los valores de X e Y deben ser multiplos de 70"

crearMundo: unaSuperficie

|mundo nroRepeticionesEnX nroRepeticionesEnY posicionActual cuadriculaNueva|

"Chequear datos ingresados"

((unaSuperficie x isDivisibleBy: 70) & (unaSuperficie y isDivisibleBy: 70))
ifFalse: [ self error: 'Los valores ingresados deben ser multiplos de 70'].

mundo:= self new.
mundo color: (Color black alpha: 0.3).
mundo extent: unaSuperficie.

"Cuadriculado"

nroRepeticionesEnX:= mundo extent x // 70.
nroRepeticionesEnY:= mundo extent y // 70.
posicionActual:= mundo position.

(nroRepeticionesEnY) timesRepeat: 
[(nroRepeticionesEnX) timesRepeat: [ cuadriculaNueva:= CuadriculaDeMundo crearCuadriculaDeMundo.	
								cuadriculaNueva position: posicionActual.
								mundo addMorph: cuadriculaNueva.
								posicionActual:= (posicionActual x + 70) @ (posicionActual y)].
							
	posicionActual:= (posicionActual x - (nroRepeticionesEnX * 70) @ (posicionActual y + 70)) ].

mundo caminos: Set new.

^ mundo openInWorld .! !

!Mundo methodsFor: 'caminos' stamp: 'MorellatoAriel 2/28/2012 19:54'!
actualizarCaminos: unMundoNuevo

self caminos do: [ :punto | unMundoNuevo addMorph: punto.].
self caminos do: [ :punto | unMundoNuevo caminos add: punto.]! !

!Mundo methodsFor: 'extenciones' stamp: 'MorellatoAriel 3/1/2012 00:23'!
ampliarParaMoverEnX: unaLongitud delRobot: unRobot

((unRobot left - unRobot mundo left)abs <= unaLongitud)
"Se extiende al oeste"
ifTrue: [ self extenderAlOeste: unaLongitud.
		self robot reasignarRobot .] .

(((unRobot left + unRobot extent x)-(unRobot mundo left + unRobot mundo extent x))abs <= unaLongitud) 
"Se extiende al este"
ifTrue: [ self extenderAlEste: unaLongitud.
		self robot reasignarRobot . ].! !

!Mundo methodsFor: 'extenciones' stamp: 'MorellatoAriel 3/1/2012 00:23'!
ampliarParaMoverEnY: unaLongitud delRobot: unRobot

((unRobot top - unRobot mundo top)abs <= unaLongitud) 
"Se extiende al norte"
ifTrue: [ self extenderAlNorte:  unaLongitud.
		self robot reasignarRobot  .] .

(((unRobot top + unRobot extent y)-(unRobot mundo top + unRobot mundo extent y))abs <= unaLongitud)
"Se extiende al sur"
ifTrue: [ self extenderAlSur:  unaLongitud.
		self robot reasignarRobot  .]! !

!Mundo methodsFor: 'accessing' stamp: 'MorellatoAriel 2/28/2012 19:37'!
caminos
	^ caminos! !

!Mundo methodsFor: 'accessing' stamp: 'MorellatoAriel 2/28/2012 19:37'!
caminos: anObject
	caminos := anObject! !

!Mundo methodsFor: 'caminos' stamp: 'MorellatoAriel 2/28/2012 19:31'!
dibujarLineaDesde: ptoInicio conLongitud: unaLongitud conInclinacion: unAngulo

|ptoActual longEnX longEnY puntoDibujado|

ptoActual:= ptoInicio.
longEnX:= self robot angle cos * 2.
longEnY:= self robot angle sin * 2.


(unaLongitud // 2) timesRepeat: 
[ 	puntoDibujado:= self dibujarPunto: ptoActual.
	self addMorph: puntoDibujado.
	ptoActual:= (ptoActual x + longEnX) @ (ptoActual y - longEnY).]

! !

!Mundo methodsFor: 'caminos' stamp: 'MorellatoAriel 2/28/2012 19:40'!
dibujarPunto: posicion

|nuevoPunto|

nuevoPunto:= Morph new.
nuevoPunto extent: 2@2.
nuevoPunto position: posicion.
self caminos add: nuevoPunto.
^ nuevoPunto openInWorld .! !

!Mundo methodsFor: 'extenciones' stamp: 'MorellatoAriel 2/28/2012 19:45'!
extenderAlEste: unaLongitud

|cuadriculasAExtender nuevoMundo|

cuadriculasAExtender:= (unaLongitud // 70 ) + 1.
nuevoMundo:= Mundo crearMundo: (self extent x + (cuadriculasAExtender * 70)) @ (self extent y ).
nuevoMundo position: self position.
self actualizarCaminos: nuevoMundo.
nuevoMundo robot: self robot.
self robot mundo: nuevoMundo.
self delete.
^ nuevoMundo openInWorld .
! !

!Mundo methodsFor: 'extenciones' stamp: 'MorellatoAriel 2/28/2012 19:37'!
extenderAlNorte: unaLongitud

|cuadriculasAExtender nuevoMundo|

cuadriculasAExtender:= (unaLongitud // 70 ) + 1.
nuevoMundo:= Mundo crearMundo: (self extent x) @ (self extent y + (cuadriculasAExtender * 70)).
nuevoMundo position: (self position x) @ (self position y - (cuadriculasAExtender * 70)).
self actualizarCaminos: nuevoMundo.
nuevoMundo robot: self robot.
self robot mundo: nuevoMundo.
self delete.
^ nuevoMundo openInWorld .
! !

!Mundo methodsFor: 'extenciones' stamp: 'MorellatoAriel 2/28/2012 19:45'!
extenderAlOeste: unaLongitud

|cuadriculasAExtender nuevoMundo|

cuadriculasAExtender:= (unaLongitud // 70 ) + 1.
nuevoMundo:= Mundo crearMundo: (self extent x + (cuadriculasAExtender * 70)) @ (self extent y ).
nuevoMundo position: (self position x - (cuadriculasAExtender * 70) @ (self position y)).
self actualizarCaminos: nuevoMundo.
nuevoMundo robot: self robot.
self robot mundo: nuevoMundo.
self delete.
^ nuevoMundo openInWorld .
! !

!Mundo methodsFor: 'extenciones' stamp: 'MorellatoAriel 2/28/2012 19:45'!
extenderAlSur: unaLongitud

|cuadriculasAExtender nuevoMundo|

cuadriculasAExtender:= (unaLongitud // 70 ) + 1.
nuevoMundo:= Mundo crearMundo: (self extent x) @ (self extent y + (cuadriculasAExtender * 70)).
nuevoMundo position: self position.
self actualizarCaminos: nuevoMundo.
nuevoMundo robot: self robot.
self robot mundo: nuevoMundo.
self delete.
^ nuevoMundo openInWorld .
! !

!Mundo methodsFor: 'accessing' stamp: 'MorellatoAriel 2/27/2012 23:32'!
robot
	^ robot! !

!Mundo methodsFor: 'accessing' stamp: 'MorellatoAriel 2/27/2012 23:32'!
robot: anObject
	robot := anObject! !

BorderedMorph subclass: #CuadriculaDeMundo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pharobot'!

!CuadriculaDeMundo class methodsFor: 'crear instancia' stamp: 'MorellatoAriel 2/28/2012 19:34'!
crearCuadriculaDeMundo

|cuadricula|
cuadricula:= BorderedMorph new.
cuadricula extent: 70@70.
cuadricula borderWidth: 1.
cuadricula color: (Color black alpha: 0).
^ cuadricula openInWorld .! !

Object subclass: #EstadoDelRobot
	instanceVariableNames: 'robot'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pharobot'!

!EstadoDelRobot class methodsFor: 'crear instancia' stamp: 'MorellatoAriel 2/28/2012 00:17'!
"Luego de crear un EstadoDelRobot  hay que mandarle el mensaje inicializarEstadoEnRobot "

crearEstado: unRobot

|estado|

estado:= self new.
estado robot: unRobot.
^ estado.! !

!EstadoDelRobot methodsFor: 'inicializacion' stamp: 'MorellatoAriel 2/28/2012 00:19'!
inicializarEstadoEnRobot

"El robot comienza con un EsadoActual = Estado_PincelArriba"
self subclassResponsibility .! !

!EstadoDelRobot methodsFor: 'movimientos' stamp: 'MorellatoAriel 3/1/2012 11:49'!
mover: unaLongitud

|movimientoEnX movimientoEnY|

movimientoEnX:= self robot angle cos * unaLongitud.
movimientoEnY:= self robot angle sin * unaLongitud.

"Movimiento en x"

self robot position: (self robot position x + movimientoEnX) @ (self robot position y).
self robot mundo ampliarParaMoverEnX: movimientoEnX abs delRobot: self robot.

"Movimiento en y"

self robot position: (self robot position x) @ (self robot position y - movimientoEnY).
self robot mundo ampliarParaMoverEnY: movimientoEnY abs delRobot: self robot.
"Actualizo ultima posicion"

self robot ultimaPosicion: self robot position .
! !

!EstadoDelRobot methodsFor: 'pincel' stamp: 'MorellatoAriel 2/28/2012 00:12'!
pincelAbajo

self subclassResponsibility .! !

!EstadoDelRobot methodsFor: 'pincel' stamp: 'MorellatoAriel 2/28/2012 00:12'!
pincelArriba

self subclassResponsibility .! !

!EstadoDelRobot methodsFor: 'accessing' stamp: 'MorellatoAriel 2/28/2012 00:11'!
robot
	^ robot! !

!EstadoDelRobot methodsFor: 'accessing' stamp: 'MorellatoAriel 2/28/2012 00:11'!
robot: anObject
	robot := anObject! !

EstadoDelRobot subclass: #Estado_PincelAbajo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pharobot'!

!Estado_PincelAbajo methodsFor: 'inicializacion' stamp: 'MorellatoAriel 2/28/2012 16:53'!
inicializarEstadoEnRobot 

self robot estado_pincelAbajo: self.! !

!Estado_PincelAbajo methodsFor: 'movimientos' stamp: 'MorellatoAriel 3/1/2012 11:35'!
mover: unaLongitud

|posicionInicial|

posicionInicial:= self robot ultimaPosicion.

super mover: unaLongitud.
self robot mundo dibujarLineaDesde: posicionInicial conLongitud: unaLongitud conInclinacion: self robot angle.! !

!Estado_PincelAbajo methodsFor: 'pincel' stamp: 'MorellatoAriel 2/28/2012 17:40'!
pincelAbajo 

^ true.! !

!Estado_PincelAbajo methodsFor: 'pincel' stamp: 'MorellatoAriel 2/28/2012 17:40'!
pincelArriba 

^ false.! !

EstadoDelRobot subclass: #Estado_PincelArriba
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pharobot'!

!Estado_PincelArriba methodsFor: 'inicializacion' stamp: 'MorellatoAriel 2/28/2012 00:19'!
inicializarEstadoEnRobot 

self robot estado_pincelArriba: self.
self robot estado_pincelActual: self.! !

!Estado_PincelArriba methodsFor: 'pincel' stamp: 'MorellatoAriel 2/28/2012 17:40'!
pincelAbajo  

^ false.! !

!Estado_PincelArriba methodsFor: 'pincel' stamp: 'MorellatoAriel 2/28/2012 17:40'!
pincelArriba 

^ true.! !
